﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Pipes;
using System.Security.Principal;
using System.Security.AccessControl;
using System.Threading;

namespace VirtualPrinter_Client_Sample
{
    /// <summary>
    /// 
    /// </summary>
    public class PipeServer
    {

        /// <summary>
        /// 
        /// </summary>
        public static void ServerStart()
        {
            String ServerName = "99073F34DF414861970DC35690876B7E";
            // WIN_API uses the other format of pipe names - "\\\\.\\pipe\\99073F34DF414861970DC35690876B7E"
            int PipeBuffer = 4096;

                PipeSecurity ServerSecurity = new PipeSecurity();
                SecurityIdentifier sid = new SecurityIdentifier(WellKnownSidType.WorldSid, null); // getting id for "Everyone" group
                
                // The following specifies who can access the pipe-server and the rights of access.
                ServerSecurity.AddAccessRule
                    (new PipeAccessRule(sid, PipeAccessRights.FullControl, AccessControlType.Allow));
                //ServerSecurity.AddAccessRule
                    //(new PipeAccessRule(System.Security.Principal.WindowsIdentity.GetCurrent().Name, PipeAccessRights.FullControl, AccessControlType.Allow));
                ServerSecurity.AddAccessRule
                    (new PipeAccessRule("SYSTEM", PipeAccessRights.FullControl, AccessControlType.Allow));

                using (NamedPipeServerStream PipeServer = new NamedPipeServerStream(
                        ServerName,
                        PipeDirection.InOut,
                        NamedPipeServerStream.MaxAllowedServerInstances,
                        PipeTransmissionMode.Message,
                        PipeOptions.None,
                        PipeBuffer,
                        PipeBuffer,
                        ServerSecurity,
                        HandleInheritability.None,
                        PipeAccessRights.ChangePermissions))
                {
                    PipeServer.SetAccessControl(ServerSecurity);
                    try
                    {
                        PipeServer.WaitForConnection();
                        using (StreamReader sr = new StreamReader(PipeServer, System.Text.Encoding.Unicode))
                        {
                            String str;
                            str = sr.ReadToEnd();
                            Program.PathToINI = str;
                            MessageBox.Show("Path has been received through named pipe: \n" + str); // Do something with received message.
                            Program.FileParser(Program.PathToINI); // Method for parsing the INI file.
                        }
                        PipeServer.Close();
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("Failed to transmit path of INI file through the named pipe.");
                    }
                }
            }
        }
}
